require 'spec_helper'

module Parsefiles

  describe FileOps do


    let(:filename) { File.join('spec', 'fixtures', 'compressed.tar.gz')}
    let(:file) {FileOps.new(filename,"test")}


    context "when working with files" do

      it "identifies the file type" do
        expect(file.get_file_type).to eq "gz"
      end

      it "force UTF-8 encoding" do
        string = "a\xFAb"
        expect(file.encode_string(string)).to eq "ab"
      end

      it "calls parse method name based on file type" do
        allow(file).to receive(:parse_gz).and_return ''
        allow(file.parse_file).to receive(:parse_gz)
      end
    end

    context 'when checking for matches' do

      it "output the line when pattern is matched" do
        line = "this do be a test"
        expect(file.match_line(line)).to eq line
      end
    end

    context 'when parsing zip files' do
      let(:zip_file) { File.join('spec', 'fixtures', 'compressed.zip')}
      let(:file) {FileOps.new(zip_file,"ctsimpso$")}

      it "outputs matched content from a compressed zip file" do
        skip "Zip files not yet implemented"
      end
    end
  end
end
